//-----------init values---------------
var typeCount = 0;
var wordsPerPost = 250;
var postCount = 0;
var subCount = 0;
var subRate = 0;
var clickRate = 0;
var totalClicks = 0;
var totalMoney = 0;
var moneyRate = 0;
var postTimer = 0;
var goneIdleBefore = false;

//increase clicks according to click rate
setInterval(function() {
	incClickCount();
	incTotalMoney();
	incSubs();
	incPostTimer();
}, 1);

function init() {
	refreshMetrics();
}

//---------------------functions--------------------

//updates all metrics/displays on screen
function refreshMetrics() {
	//update money made
	document.getElementById("money-bar").innerHTML = "Total Money Made from Blogging: $"+totalMoney.toFixed(2);
	//update metric divs
	document.getElementById("type-count").innerHTML = "Words Needed for Next Post:<br>"+(wordsPerPost-typeCount);
	document.getElementById("metric-posts").innerHTML = "Post Count:<br>"+postCount;
	document.getElementById("metric-subscribers").innerHTML = "Subscriber Count:<br>"+Math.floor(subCount);
	document.getElementById("metric-clicks").innerHTML = "Total Clicks:<br>"+Math.floor(totalClicks);
	//scroll updates to bottom
	document.getElementById("update-feed").scrollTop = document.getElementById("update-feed").scrollHeight;
	//move progress bar
	document.getElementById("type-percent-bar").style.width = 100*typeCount/wordsPerPost + "%";
}

//every time key is pressed, increase typeCount, update display, and trigger other events as needed
function incTypeCount() {
	typeCount = typeCount + 1;
	if (typeCount >= wordsPerPost) {
		incPostCount();
	}
	refreshMetrics();
}

function incPostCount() {
	postTimer = 0;
	postCount = postCount + 1;
	typeCount = typeCount - wordsPerPost;
	//post updates for landmark post numbers
	var update = "";
	switch(postCount) {
		case 1:
			update = "<br>You posted your first post! Soon people will start to visit your blog!";
			subRate = 0.00001;
			break;
		case 5:
			update = "<br>That's 5 posts! You've unlocked the Custom Domain upgrade.";
			document.getElementById("domain").innerHTML = "<img src=\"img/custom_domain.png\" alt=\"custom domain name\"/>";
			document.getElementById("domain").setAttribute("onclick","selectStoreItem('domain')");
			break;
		case 10:
			update = "<br>10 posts! Keep it up!";
			break;
		case 15:
			update = "<br>You've unlocked the SEO upgrade.";
			document.getElementById("seo").innerHTML = "<img src=\"img/optimize_seo.png\" alt=\"optimize your seo\"/>";
			document.getElementById("seo").setAttribute("onclick","selectStoreItem('seo')");
			break;
		case 25:
			update = "<br>25 posts, woohoo!";
			break;
		case 30:
			update = "<br>You've unlocked the Custom Logo upgrade.";
			document.getElementById("logo").innerHTML = "<img src=\"img/logo.png\" alt=\"custom logo\"/>";
			document.getElementById("logo").setAttribute("onclick","selectStoreItem('logo')");
			break;
		case 40:
			update = "<br>You've unlocked the Sidebar Ads upgrade.";
			document.getElementById("ads").innerHTML = "<img src=\"img/add_ads.png\" alt=\"put ads on your blog\"/>";
			document.getElementById("ads").setAttribute("onclick","selectStoreItem('ads')");
			break;
		case 50:
			update = "<br>You made it to 50 posts!";
			break;
		case 60:
			update = "<br>You've unlocked the Giveaway Post upgrade.";
			document.getElementById("giveaway").innerHTML = "<img src=\"img/giveaway.png\" alt=\"giveaway post\"/>";
			document.getElementById("giveaway").setAttribute("onclick","selectStoreItem('giveaway')");
			break;
		case 75:
			update = "<br>You've unlocked the Affiliate Marketing upgrade.";
			document.getElementById("affiliate").innerHTML = "<img src=\"img/affiliate.png\" alt=\"affiliate marketing\"/>";
			document.getElementById("affiliate").setAttribute("onclick","selectStoreItem('affiliate')");
			break;
		case 85:
			update = "<br>You've unlocked the Newsletter upgrade.";
			document.getElementById("newsletter").innerHTML = "<img src=\"img/newsletter.png\" alt=\"start a newsletter\"/>";
			document.getElementById("newsletter").setAttribute("onclick","selectStoreItem('newsletter')");
			break;
		case 100:
			update = "<br>Wow! 100 posts!";
			break;
		case 150:
			update = "<br>You've unlocked the Merch upgrade.";
			document.getElementById("merch").innerHTML = "<img src=\"img/merch.png\" alt=\"sell merch\"/>";
			document.getElementById("merch").setAttribute("onclick","selectStoreItem('merch')");
			break;
		case 250:
			update = "<br>That's your 250th post! Super!"
			break;
		case 500:
			update = "<br>Way to go, you've published 500 posts!<br>You've unlocked the final upgrade: Book Deal!";
			document.getElementById("book").innerHTML = "<img src=\"img/book_deal.png\" alt=\"get a book deal\"/>";
			document.getElementById("book").setAttribute("onclick","selectStoreItem('book')");
			break;
		case 1000:
			update = "<br>That's 1000 posts! Great job!"
			break;
		default: 
			update = "";
	}
	document.getElementById("update-feed").innerHTML = document.getElementById("update-feed").innerHTML + update;
	//click rate goes up with each post
	clickRate = clickRate + 0.001;
	refreshMetrics();
	//add new latest post headline
	document.getElementById("headlines").innerHTML = "<b>Latest Post:</b> "+getRandomHeadline();
}

function incClickCount() {
	totalClicks = totalClicks + clickRate;
	document.getElementById("metric-clicks").innerHTML = "Total Clicks:<br>"+Math.floor(totalClicks);
}

function incTotalMoney() {
	totalMoney = totalMoney + moneyRate*totalClicks;
	document.getElementById("money-bar").innerHTML = "Total Money Made from Blogging: $"+totalMoney.toFixed(2);
}

function incSubs() {
	subCount = subCount + subRate*totalClicks;
	document.getElementById("metric-subscribers").innerHTML = "Subscriber Count:<br>"+Math.floor(subCount);
}

function incPostTimer() {
	postTimer = postTimer + 1;
	if (postTimer > 20000) {
		postTimer = 0;
		if (goneIdleBefore==false) {
			document.getElementById("update-feed").innerHTML = document.getElementById("update-feed").innerHTML + "<br>Careful! If you go too long without posting, people will stop reading your blog.";
			goneIdleBefore = true;
		}
		clickRate = 0.70*clickRate;
		subRate = 0.70*subRate;
		if (subCount>0) {
			subCount = subCount - 0.05*subCount;
		}
	}
}

function selectStoreItem(item) {
	var content = "";
	switch(item) {
		case "unknown":
			content = "<h2>Unknown Upgrade</h2><p>An unknown upgrade. Keep writing posts to unlock it!</p>";
			break;
		case "domain":
			content = "<h2>Custom Domain Name</h2><p>Buy a custom domain name like blog.com to replace your old, clunky URL. Increases click rate.</p><button onclick='activateItem(\"domain\")'>Activate</button>";
			break;
		case "seo":
			content = "<h2>Optimize SEO</h2><p>Update your site to include keywords designed to make you the top search result. Increases click rate.</p><button onclick='activateItem(\"seo\")'>Activate</button>";
			break;
		case "logo":
			content = "<h2>Custom Logo</h2><p>Design a custom logo to give your site a little extra style. Increases subscriber rate.</p><button onclick='activateItem(\"logo\")'>Activate</button>";
			break;
		case "ads":
			content = "<h2>Sidebar Ads</h2><p>Sign up to put ads in the sidebars of your blog. Starts earning you money from clicks.</p><button onclick='activateItem(\"ads\")'>Activate</button>";
			break;
		case "giveaway":
			content = "<h2>Giveaway Post</h2><p>Make a giveaway post to entice new followers. Increases subscriber rate.</p><button onclick='activateItem(\"giveaway\")'>Activate</button>";
			break;
		case "affiliate":
			content = "<h2>Affiliate Marketing</h2><p>Sign up for affiliate marketing so you can make money off of people using your links. Increases revenue per click.</p><button onclick='activateItem(\"affiliate\")'>Activate</button>";
			break;
		case "newsletter":
			content = "<h2>Start a Newsletter</h2><p>Start a newsletter to keep your subscribers engaged. Increases click rate.</p><button onclick='activateItem(\"newsletter\")'>Activate</button>";
			break;
		case "merch":
			content = "<h2>Sell Merch</h2><p>Let your subscribers buy shirts with your blog's name on them! Increases revenue.</p><button onclick='activateItem(\"merch\")'>Activate</button>";
			break;
		case "book":
			content = "<h2>Get a Book Deal</h2><p>It's the dream: write a book based on your blog! Increases subscribers and revenue.</p><button onclick='activateItem(\"book\")'>Activate</button>";
			break;
	}
	document.getElementById("store-desc").innerHTML = content;
}

function activateItem(item) {
	var update = "";
	switch (item) {
		case "domain":
			clickRate = clickRate * 2;
			update = "<br>Custom Domain activated!";
			break;
		case "seo":
			clickRate = clickRate * 2;
			update = "<br>SEO Optimization activated!";
			break;
		case "logo":
			subRate = subRate * 2;
			update = "<br>Custom Logo activated!";
			break;
		case "ads":
			moneyRate = 0.0000001;
			document.getElementById("ad1").style.display = "block";
			document.getElementById("ad2").style.display = "block";
			update = "<br>Sidebar Ads activated!";
			break;
		case "giveaway":
			subRate = subRate * 2;
			update = "<br>Giveaway Post activated!";
			break;
		case "affiliate":
			moneyRate = moneyRate * 5;
			update = "<br>Affiliate Marketing activated!";
			break;
		case "newsletter":
			clickRate = clickRate * 2;
			update = "<br>Newsletter activated!";
			break;
		case "merch":
			moneyRate = moneyRate * 2;
			update = "<br>Merch activated!";
			break;
		case "book":
			subRate = subRate * 5;
			moneyRate = moneyRate * 5;
			update = "<br>Book Deal activated!";
			break;
	}
	document.getElementById(item).style.display = "none";
	document.getElementById("store-desc").innerHTML = "";
	document.getElementById("update-feed").innerHTML = document.getElementById("update-feed").innerHTML + update;
}

function getRandomHeadline() {
	//set up tracery grammar
	headlineRules = {
	"origin" : "#phrase#",
	"phrase" : ["What #personality.capitalize# Are You Based On Your Favorite #favorite.capitalize#?","#num# #media-type.s.capitalize# of #animal.s.capitalize# That Will Make You Feel #emotion.capitalize#","The #num# Most #adjective.capitalize# Scenes From #tv-movie#","#num# #adjective.capitalize# Things Only #decade# Kids Will Remember","This #animal.capitalize# Met #animal.capitalize.a#. You Won't Believe What Happens Next!","#num# Ways to #activity.capitalize#. The Last One Will Make You #activity.capitalize#!","Thinking of Learning to #activity.capitalize#? You Better Read These #num# Tips First!"],
	"num" : ["3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30"],
	"personality" : ["Hogwarts House","Zodiac Sign","Meyers-Briggs Type","D&D Class","#tv-movie# Character","Game of Thrones House"],
	"favorite" : ["Pizza Toppings","Sandwich","Tea","Juice","Soda","#tv-movie# Character","Ice Cream Flavor","Condiment","Doritos Flavor","Web Browser","Code Editor","Type of Cheese","Flower"],
	"tv-movie" : ["Game of Thrones","Harry Potter","Riverdale","Star Wars","Star Trek","E.R.","30 Rock","Scooby Doo","Bones","Breaking Bad","Spongebob","Columbo","Danny Phantom","Futurama","She-Ra","Powerpuff Girls","Kung Fu Panda","Friends","Mad Men","Miss Fisher's Murder Mysteries","Murder She Wrote","My Little Pony","X-Files","Power Rangers","Sherlock","Dr. Who","Supernatural","Backyardigans","Looney Tunes","The Flintstones","The Munsters","The Addams Family","Muppet Show","True Blood","Wizards of Waverly Place","Hannah Montana","Zooboomafoo","Lord of the Rings","Indiana Jones","Toy Story","Mad Max","The Princess Bride","The Breakfast Club","Jurassic Park","The Matrix"],
	"media-type" : ["picture","video","pic","photo"],
	"animal" : ["cat","kitten","dog","puppy","cow","pig","kangaroo","aardvark","alligator","alpaca","antelope","ape","armadillo","baboon","badger","bat","bear","boar","buffalo","bull","camel","capybara","chameleon","cheetah","chimpanzee","chinchilla","chipmunk","coyote","crocodile","crow","deer","donkey","elephant","ferret","frog","gazelle","giraffe","gnu","goat","gopher","gorilla","groundhog","hamster","hedgehog","horse","hyena","iguana","impala","jackal","jaguar","koala","lamb","lemur","leopard","lion","lizard","llama","mole","mongoose","monkey","moose","newt","ocelot","opossum","orangutan","otter","panda","panther","parakeet","parrot","porcupine","porpoise","rabbit","raccoon","rat","salamander","sheep","skunk","snake","squirrel","tiger","toad","turtle","warthog","whale","wombat","woodchuck","yak","zebra"],
	"emotion" : ["happy","sad","confused","bewildered","proud","glad","sleepy","calm","carefree","cheerful","amused","blessed","chagrined","annoyed","befuddled","apathetic","ecstatic","alarmed","enthusiastic","enlightened","flabbergasted","foolish","astonished","fretful","astounded","baffled","gloomy","bored","homesick","hopeful","captivated","confident","contemplative","jittery","jolly","jovial","contented","cordial","jubilant","curious","lighthearted","meditative","melancholic","mystified","distracted","motivated","merry","nostalgic","peaceful","pensive","perplexed","playful","puzzled","quizzical","reflective","relieved","serene","smug","surprised","thankful","tranquil"],
	"adjective" : ["absorbing","admired","athletic","boring","brazen","cantankerous","carefree","cathartic","cherished","conceptual","confusing","cosmic","cryptic","dashing","dazzling","despairing","devastating","devilish","disdainful","disheveled","disillusioned","draining","economical","emotional","engrossing","enthralling","esoteric","essential","evergreen","exasperating","exciting","extraordinary","fallacious","fancy","fearless","flammable","floral","foggy","foolish","formulaic","foul-mouthed","grammatical","hopeless","horrendous","horrible","hypnotizing","immersive","incomprehensible","insufferable","interesting","intolerable","joyful","laughable","literary","low-budget","lovely","meaningful","memorable","mind-blowing","mind-boggling","muscular","motorized","mysterious","multidisciplinary","nail-biting","nonsensical","nuanced","open-ended","philosophical","prescient","ridiculous","scandalous","stylized","timely","transformative","unearthly","eldritch","uninspired","visceral","woeful","wistful"],
	"decade" : ["00's","10's","20's","30's","40's","50's","60's","70's","80's","90's"],
	"activity" : ["Ride a Bike","Paint a Sunrise","Take a Selfie","Hike a Mountain","Write a Novel","Code a Website","Jump Up and Down","Jump Rope","Catch a Fish","Look at Birds","Ride a Motorcycle","Throw Your Computer Out the Window","Visit Your Grandmother","Eat Some Pasta","Bake a Cake","Pet Your Cat","Sew a Dress","Buy an Air Conditioner","Shriek into the Void of Space","Stare at the Moon","Climb a Tree","Solve a Mystery","Commit Arson","Build a House","Fix Your Furnace","Adopt #animal.capitalize.a#","Braid Your Hair","Code a Game","Draw a Dinosaur","Listen to a Podcast","Charge Your Phone","Feel #emotion.capitalize#"],
	};
	var headlineGrammar = tracery.createGrammar(headlineRules);
	//generate random headline
	var trace = headlineGrammar.flatten("#origin#");
	return(trace);
}